/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/08/10 10:10:06
 */
import { Component } from 'wkit'
import { createWebHashHistory, createWebHistory } from './router-engine.js'
import './router-components.js'
import { __ROUTER__ } from '../constants.js'

export { createWebHashHistory, createWebHistory }

export function createRouter({
  history = createWebHashHistory(),
  routes = []
} = {}) {
  let $router = history()

  window.wkitd.set(__ROUTER__, $router)

  $router.addRoute(routes)
  function wrapper() {
    Object.defineProperty(Component.prototype, '$router', {
      get() {
        return window.wkitd.get(__ROUTER__)
      },
      set(val) {
        console.error('Can not set readonly property $router of Component')
      },
      enumerable: false
    })
  }
  wrapper.beforeEach = $router.beforeEach.bind($router)
  return wrapper
}
